// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
angular.module('App', ['ionic','ngCordova'])
    .config(function($stateProvider, $urlRouterProvider) {
      $stateProvider
          .state('login',{
            url:'/login',
            cache:false,
            controller:'LoginController',
            templateUrl:'views/login/login.html'
          })
          .state('home',{
            url:'/home',
            abstract:true,
            templateUrl:'views/home/home.html'
          })
          .state('home.items',{
            url:'/items',
            cache:false,
            views: {
              'all-items': {
                controller:'ItemsController',
                templateUrl:'views/items/items.html'
              }
            }
          })
          .state('home.search',{
            url:'/search',
            views:{
              'all-items':{
                  controller:'SearchController',
                  templateUrl:'views/items/search.html'
              }
            }
          })
          .state('home.items_info',{
              url:'/items_info/:assign_id',
              cache:false,
              views:{
                  'all-items':{
                      controller:'ItemsInfoController',
                      templateUrl:'views/items/info.html'
                  }
              }
          })
          .state('home.my_items',{
              url:'/my_items',
              cache:false,
              views: {
                  'all-items': {
                      controller:'MyItemsController',
                      templateUrl:'views/my/my_items.html'
                  }
              }
          })
          .state('home.my_info',{
              url:'/my_info/:assign_id',
              cache:false,
              views:{
                  'all-items':{
                      controller:'MyInfoController',
                      templateUrl:'views/my/my_info.html'
                  }
              }
          })
          .state('home.my_edit',{
              url:'/my_edit/:assign_id',
              cache:false,
              views:{
                  'all-items':{
                      controller:'MyEditController',
                      templateUrl:'views/my/my_edit.html'
                  }
              }
          })
          .state('home.my_step1',{
              url:'/my_step1/:assign_id',
              cache:false,
              views:{
                  'all-items':{
                      controller:'MyStep1Controller',
                      templateUrl:'views/my/my_step1.html'
                  }
              }
          })
          .state('home.my_step2',{
              url:'/my_step2/:assign_id',
              cache:false,
              views:{
                  'all-items':{
                      controller:'MyStep2Controller',
                      templateUrl:'views/my/my_step2.html'
                  }
              }
          });
      $urlRouterProvider.otherwise('/login');
    })

.run(function($ionicPlatform) {
  $ionicPlatform.ready(function() {
    if(window.cordova && window.cordova.plugins.Keyboard) {
      // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
      // for form inputs)
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);

      // Don't remove this line unless you know what you are doing. It stops the viewport
      // from snapping when text inputs are focused. Ionic handles this internally for
      // a much nicer keyboard experience.
      cordova.plugins.Keyboard.disableScroll(true);
    }
    if(window.StatusBar) {
      StatusBar.styleDefault();
    }
  });
})
