/**
 * Created by chaoxinzeng on 16/9/27.
 */
angular.module('App')
    .controller('MyEditController',function($scope,$state,$filter,$stateParams,$ionicLoading,$ionicPopup,$ionicHistory,$http,RemoteUrl,Storage){
        var info = {};
        $scope.cardInfo = {
            address:'',
            address2:'',
            send_date:'',
            obj_date:new Date(),
            assign_id:$stateParams.assign_id
        };

        $scope.readInfo=function(){
            var assign_id = $stateParams.assign_id;
            $ionicLoading.show();
            $http.get(RemoteUrl.order_info_url,{params: { assign_id:assign_id}})
                .success(function(res) {
                    $scope.info = res.data;
                    $ionicLoading.hide();
                    $scope.cardInfo.address = $scope.info.send_address;
                    $scope.cardInfo.address2 = $scope.info.send_address2;
                    $scope.cardInfo.send_date = $scope.info.send_date;
                    $scope.cardInfo.obj_date = new Date($scope.info.send_date);
                }).error(function(err, status) {
                $ionicLoading.show({
                    noBackdrop: true,
                    template: err,
                    duration: 1500
                });
            });
        };
        $scope.readInfo();

        //保存地址信息
        $scope.saveInfo = function() {
            var cardInfo = $scope.cardInfo;
            var send_date = '';
            if(cardInfo.address == '') {
                $ionicPopup.alert({
                    title: '错误提示',
                    template: '请输入送单地址!'
                });
                return;
            }
            cardInfo.send_date = $filter('date')(cardInfo.obj_date, 'yyyy-MM-dd');
            if(cardInfo.send_date == '') {
                $ionicPopup.alert({
                    title: '错误提示',
                    template: '请输入送单时间!'
                });
                return;
            }

            if(cardInfo.address2 == '') {
                $ionicPopup.alert({
                    title: '错误提示',
                    template: '请输入正本送单地址!'
                });
                return;
            }
            $ionicLoading.show();
            $http.get(RemoteUrl.save_info_url, {
                params: cardInfo
            })
                .success(function (res) {
                    $ionicLoading.hide();
                    if(res.success) {
                        $ionicPopup.alert({
                            title: '提示',
                            template: res.msg
                        });
                        $state.go('home.my_info',{assign_id:$stateParams.assign_id});
                    } else {
                        $ionicPopup.alert({
                            title: '错误提示',
                            template: res.msg
                        });
                    }
                }).error(function (err, status) {
                $ionicLoading.show({
                    noBackdrop: true,
                    template: err,
                    duration: 1500
                });
            });
        };
    });