/**
 * Created by chaoxinzeng on 16/9/27.
 */
angular.module('App')
    .controller('MyInfoController',function($scope,$state,$filter,$stateParams,$ionicActionSheet,$ionicLoading,$ionicPopup,$ionicHistory,$cordovaImagePicker,$http,RemoteUrl,Camera,Storage){
        var info = {};
        $scope.theFrm = {
            sms_code:''
        };
        $scope.cardInfo = {
            cardnumber:'',
            address:'',
            address2:'',
            name:'',
            nation:'',
            issuingauthority:'',
            validstartdate:'',
            validenddate:'',
            phone:'',
            assign_id:$stateParams.assign_id
        };

        //上传照片
        $scope.uploadimage = function(uri, prop) {
            var fileURL = uri;
            var options = new FileUploadOptions();
            options.fileKey = "pic";
            options.fileName = fileURL.substr(fileURL.lastIndexOf('/') + 1);
            options.mimeType = "image/jpeg";
            options.chunkedMode = true;

            var params = {
                assign_id: $scope.cardInfo.assign_id,
                type:prop
            }

            options.params = params;

            var ft = new FileTransfer();
            $ionicLoading.show({
                template: '上传中...'
            });
            ft.upload(fileURL, RemoteUrl.upload_url, function(data) {
                // 设置图片新地址
                // alert(data.response);
                var resp = JSON.parse(data.response);
                if(resp.success) {
                    if(resp.obj.config.side == 'face') {
                        obj = resp.obj;
                        $scope.cardInfo.nation = obj.nationality + '族';
                        // alert($scope.cardInfo.nation);
                        $scope.cardInfo.cardnumber = obj.num;
                        // alert($scope.cardInfo.cardnumber);
                        $scope.cardInfo.name = obj.name;
                        // alert($scope.cardInfo.name);
                        $scope.cardInfo.address = obj.address;
                        // alert($scope.cardInfo.address);
                        $ionicPopup.alert({
                            title: '提示',
                            template: resp.msg
                        });
                    }
                    if(resp.obj.config.side == 'back') {
                        obj = resp.obj;
                        $scope.cardInfo.issuingauthority = obj.issue;
                        // alert($scope.cardInfo.nation);
                        $scope.cardInfo.validstartdate = new Date(obj.start_date);
                        // alert($scope.cardInfo.validstartdate);
                        $scope.cardInfo.validenddate = new Date(obj.end_date);
                        // alert($scope.cardInfo.validenddate);
                        alert(resp.msg);
                        $ionicPopup.alert({
                            title: '提示',
                            template: resp.msg
                        });
                    }
                } else {
                    $ionicPopup.alert({
                        title: '提示',
                        template: resp.msg
                    });
                }
                $ionicLoading.hide();
            }, function(error) {
                alert(JSON.stringify(error));
                $ionicLoading.hide();
            }, options);
        };

        $scope.readInfo=function(){
            var assign_id = $stateParams.assign_id;
            $ionicLoading.show();
            $http.get(RemoteUrl.order_info_url,{params: { assign_id:assign_id}})
                .success(function(res) {
                    $scope.info = res.data;
                    $ionicLoading.hide();
                }).error(function(err, status) {
                $ionicLoading.show({
                    noBackdrop: true,
                    template: err,
                    duration: 1500
                });
            });
        };
        $scope.readInfo();

        //退回操作
        $scope.backOp = function() {
            var myInfo = Storage.get('myInfo');
            var assign_id = $stateParams.assign_id;
            var op_status = $scope.info.op_status;
            if (!myInfo.success) {
                $ionicPopup.alert({
                    title: '错误提示',
                    template: '请先登录!'
                });
                $ionicHistory.clearHistory();
                $state.go('login');
                return;
            }
            $ionicPopup.prompt({
                title: '退回原因'
            }).then(function (res) {
                if (res) {
                    $ionicLoading.show();
                    $http.get(RemoteUrl.order_back_url, {
                        params: {
                            assign_id: assign_id,
                            user_id: myInfo.userInfo.id,
                            op_status: op_status,
                            msg: res
                        }
                    })
                        .success(function (res) {
                            $ionicPopup.alert({
                                title: '提示',
                                template: '退回成功!'
                            });
                            $ionicHistory.goBack();
                            $ionicLoading.hide();
                        }).error(function (err, status) {
                        $ionicLoading.show({
                            noBackdrop: true,
                            template: err,
                            duration: 1500
                        });
                    });
                }
            });
        };
        //放弃操作
        $scope.cancelOp = function() {
            var myInfo = Storage.get('myInfo');
            var assign_id = $stateParams.assign_id;
            var op_status = $scope.info.op_status;
            if (!myInfo.success) {
                $ionicPopup.alert({
                    title: '错误提示',
                    template: '请先登录!'
                });
                $ionicHistory.clearHistory();
                $state.go('login');
                return;
            }
            $ionicPopup.confirm({
                title: '是否确定?',
                template: '是否放弃本配送单?'
            }).then(function (res) {
                if (res) {
                    $ionicLoading.show();
                    $http.get(RemoteUrl.order_cancel_url, {
                        params: {
                            assign_id: assign_id,
                            user_id: myInfo.userInfo.id
                        }
                    })
                        .success(function (res) {
                            $ionicPopup.alert({
                                title: '提示',
                                template: '放弃成功!'
                            });
                            $ionicHistory.goBack();
                            $ionicLoading.hide();
                        }).error(function (err, status) {
                        $ionicLoading.show({
                            noBackdrop: true,
                            template: err,
                            duration: 1500
                        });
                    });
                }
            });
        };
        //操作选项
        $scope.showOpChoices = function() {
            var hideSheet = $ionicActionSheet.show({
                buttons: [{
                    text: '<b>信息采集</b>'
                },{
                    text: '<b>输入验证码或无采集</b>'
                }],
                titleText: '操作',
                cancelText: '取 消',
                cancel: function() {
                    // add cancel code..
                },
                buttonClicked: function(index) {
                    // 相册文件选择上传
                    if (index == 0) {
                        $state.go('home.my_step1',{assign_id:$stateParams.assign_id});
                    } else if(index == 1) {
                        $state.go('home.my_step2',{assign_id:$stateParams.assign_id});
                    }
                    return true;
                }
            });

        };

        //读取身份证信息
        // $scope.readCardInfo = function() {
            // var assign_id = $stateParams.assign_id;
            // $http.get(RemoteUrl.read_cardinfo_url,{params:{assign_id:assign_id}})
            //     .success(function(res){
            //         $scope.cardInfo = res.cardInfo;
            //         $scope.cardInfo.validstartdate = new Date($scope.cardInfo.validstartdate);
            //         $scope.cardInfo.validenddate = new Date($scope.cardInfo.validenddate);
            //         $ionicLoading.hide();
            //     })
            //     .error(function(err,status){
            //         $ionicLoading.show({
            //             noBackdrop:true,
            //             template:err,
            //             duration:1500
            //         });
            //     });
        // };
        // $scope.readCardInfo();

        // 图片选择项
        $scope.showImageUploadChoices = function() {
            var hideSheet = $ionicActionSheet.show({
                buttons: [{
                    text: '<b>正面拍照</b>'
                },{
                    text: '<b>反面拍照</b>'
                },{
                    text: '<b>选择正面照片</b>'
                },{
                    text: '<b>选择反面照片</b>'
                }],
                titleText: '身份证识别',
                cancelText: '取 消',
                cancel: function() {
                    // add cancel code..
                },
                buttonClicked: function(index) {
                    // 相册文件选择上传
                    if (index == 0) {
                        $scope.takePhone1();
                    } else if(index == 1) {
                        $scope.takePhone2();
                    } else if(index == 2) {
                        $scope.readAlbum1();
                    } else if (index == 3) {
                        $scope.readAlbum2();
                    }
                    return true;
                }
            });

        };
        //拍照获取身份证信息
        $scope.takePhone1 = function() {
            if (!navigator.camera) {
                alert('请在真机环境中使用拍照上传。')
                return;
            }

            var options = {
                quality: 75,
                targetWidth: 1000,
                targetHeight: 1000,
                saveToPhotoAlbum: false
            };
            Camera.getPicture(options).then(function(imageURI) {
                $scope.uploadimage(imageURI,'face');
            }, function(err) {
                alert("照相机：" + err);
            });
        };
        $scope.takePhone2 = function() {
            if (!navigator.camera) {
                alert('请在真机环境中使用拍照上传。')
                return;
            }

            var options = {
                quality: 75,
                targetWidth: 1000,
                targetHeight: 1000,
                saveToPhotoAlbum: false
            };
            Camera.getPicture(options).then(function(imageURI) {
                $scope.uploadimage(imageURI,'back');
            }, function(err) {
                alert("照相机：" + err);
            });
        };
        $scope.readAlbum1 = function() {
            if (!window.imagePicker) {
                alert('目前您的环境不支持相册上传。');
                return;
            }

            var options = {
                maximumImagesCount: 1,
                width: 1000,
                height: 1000,
                quality: 80
            };

            $cordovaImagePicker.getPictures(options).then(function(results) {
                var uri = results[0];

                $scope.uploadimage(uri, 'face');
            }, function(error) {
                alert(error);
            });
        };
        $scope.readAlbum2 = function() {
            if (!window.imagePicker) {
                alert('目前您的环境不支持相册上传。');
                return;
            }

            var options = {
                maximumImagesCount: 1,
                width: 1000,
                height: 1000,
                quality: 80
            };

            $cordovaImagePicker.getPictures(options).then(function(results) {
                var uri = results[0];

                $scope.uploadimage(uri, 'back');
            }, function(error) {
                alert(error);
            });
        };
        //保存身份证信息
        $scope.saveID = function() {
            var cardInfo = $scope.cardInfo;
            if(cardInfo.cardnumber == '') {
                $ionicPopup.alert({
                    title: '错误提示',
                    template: '请输入身份证号码!'
                });
                return;
            }
            if(cardInfo.address == '') {
                $ionicPopup.alert({
                    title: '错误提示',
                    template: '请输入身份证地址!'
                });
                return;
            }
            if(cardInfo.name == '') {
                $ionicPopup.alert({
                    title: '错误提示',
                    template: '请输入姓名!'
                });
                return;
            }
            if(cardInfo.nation == '') {
                $ionicPopup.alert({
                    title: '错误提示',
                    template: '请输入民族!'
                });
                return;
            }
            if(cardInfo.issuingauthority == '') {
                $ionicPopup.alert({
                    title: '错误提示',
                    template: '请输入签发机构!'
                });
                return;
            }
            cardInfo.validstartdate = $filter('date')(cardInfo.validstartdate, "yyyy-MM-dd");
            if(cardInfo.validstartdate == '') {
                $ionicPopup.alert({
                    title: '错误提示',
                    template: '请输入有效开始时间!'
                });
                return;
            }
            cardInfo.validenddate = $filter('date')(cardInfo.validenddate, "yyyy-MM-dd");
            if(cardInfo.validenddate == '') {
                $ionicPopup.alert({
                    title: '错误提示',
                    template: '请输入有效结束时间,长期为9999-12-31!'
                });
                return;
            }
            $ionicLoading.show();
            $http.get(RemoteUrl.save_cardinfo_url, {
                params: cardInfo
            })
                .success(function (res) {
                    if(res.success) {
                        $state.go('home.my_step2',{assign_id:$stateParams.assign_id});
                        $ionicLoading.hide();
                    } else {
                        $ionicPopup.alert({
                            title: '错误提示',
                            template: res.msg
                        });
                    }
                }).error(function (err, status) {
                $ionicLoading.show({
                    noBackdrop: true,
                    template: err,
                    duration: 1500
                });
            });
        };
        //提交验证码
        $scope.submitOp=function(){
            var assign_id = $stateParams.assign_id;
            var sms_code = $scope.theFrm.sms_code;
            if(sms_code == '') {
                $ionicPopup.alert({
                    title: '错误提示',
                    template: '请输入验证码!'
                });
                return;
            }
            $ionicLoading.show();
            $http.get(RemoteUrl.my_submit_url, {
                params: {
                    assign_id:assign_id,
                    sms_code:sms_code
                }
            })
                .success(function (res) {
                    $ionicPopup.alert({
                        title: '提示',
                        template: '保存成功!'
                    });
                    $state.go('home.my_items');
                    $ionicLoading.hide();
                }).error(function (err, status) {
                $ionicLoading.show({
                    noBackdrop: true,
                    template: err,
                    duration: 1500
                });
            });
        };
        $scope.callPhone = function (mobilePhone) {
            $window.location.href = "tel:" + mobilePhone;
        };
    });