/**
 * Created by chaoxinzeng on 16/9/27.
 */
angular.module('App')
    .controller('MyStep1Controller',function($scope,$state,$filter,$stateParams,$ionicActionSheet,$ionicLoading,$ionicPopup,$ionicHistory,$cordovaImagePicker,$http,RemoteUrl,Camera,Storage){
        var info = {};
        $scope.cardInfo = {
            cardnumber:'',
            address:'',
            address2:'',
            name:'',
            nation:'',
            issuingauthority:'',
            validstartdate:'',
            obj_validstartdate: new Date(),
            validenddate:'',
            obj_validenddate: new Date(),
            phone:'',
            assign_id:$stateParams.assign_id
        };

        //上传照片
        $scope.uploadimage = function(uri, prop) {
            var fileURL = uri;
            var options = new FileUploadOptions();
            options.fileKey = "pic";
            options.fileName = fileURL.substr(fileURL.lastIndexOf('/') + 1);
            options.mimeType = "image/jpeg";
            options.chunkedMode = true;

            var params = {
                assign_id: $scope.cardInfo.assign_id,
                type:prop
            }

            options.params = params;

            var ft = new FileTransfer();
            $ionicLoading.show({
                template: '上传中...'
            });
            ft.upload(fileURL, RemoteUrl.upload_url, function(data) {
                // 设置图片新地址
                // alert(data.response);
                var resp = JSON.parse(data.response);
                if(resp.success) {
                    if(resp.obj.config.side == 'face') {
                        obj = resp.obj;
                        $scope.cardInfo.nation = obj.nationality + '族';
                        // alert($scope.cardInfo.nation);
                        $scope.cardInfo.cardnumber = obj.num;
                        // alert($scope.cardInfo.cardnumber);
                        $scope.cardInfo.name = obj.name;
                        // alert($scope.cardInfo.name);
                        $scope.cardInfo.address = obj.address;
                        // alert($scope.cardInfo.address);
                        $ionicPopup.alert({
                            title: '提示',
                            template: resp.msg
                        });
                    }
                    if(resp.obj.config.side == 'back') {
                        obj = resp.obj;
                        $scope.cardInfo.issuingauthority = obj.issue;
                        // alert($scope.cardInfo.nation);
                        $scope.cardInfo.validstartdate = new Date(obj.start_date);
                        // alert($scope.cardInfo.validstartdate);
                        $scope.cardInfo.validenddate = new Date(obj.end_date);
                        // alert($scope.cardInfo.validenddate);
                        alert(resp.msg);
                        $ionicPopup.alert({
                            title: '提示',
                            template: resp.msg
                        });
                    }
                } else {
                    $ionicPopup.alert({
                        title: '提示',
                        template: resp.msg
                    });
                }
                $ionicLoading.hide();
            }, function(error) {
                alert(JSON.stringify(error));
                $ionicLoading.hide();
            }, options);
        };

        $scope.readInfo=function(){
            var assign_id = $stateParams.assign_id;
            $ionicLoading.show();
            $http.get(RemoteUrl.order_info_url,{params: { assign_id:assign_id}})
                .success(function(res) {
                    $scope.info = res.data;
                    $ionicLoading.hide();
                }).error(function(err, status) {
                $ionicLoading.show({
                    noBackdrop: true,
                    template: err,
                    duration: 1500
                });
            });
        };
        $scope.readInfo();

        // 图片选择项
        $scope.showImageUploadChoices = function() {
            var hideSheet = $ionicActionSheet.show({
                buttons: [{
                    text: '<b>正面拍照</b>'
                },{
                    text: '<b>反面拍照</b>'
                },{
                    text: '<b>选择正面照片</b>'
                },{
                    text: '<b>选择反面照片</b>'
                }],
                titleText: '身份证识别',
                cancelText: '取 消',
                cancel: function() {
                    // add cancel code..
                },
                buttonClicked: function(index) {
                    // 相册文件选择上传
                    if (index == 0) {
                        $scope.takePhone1();
                    } else if(index == 1) {
                        $scope.takePhone2();
                    } else if(index == 2) {
                        $scope.readAlbum1();
                    } else if (index == 3) {
                        $scope.readAlbum2();
                    }
                    return true;
                }
            });

        };
        //拍照获取身份证信息
        $scope.takePhone1 = function() {
            if (!navigator.camera) {
                alert('请在真机环境中使用拍照上传。')
                return;
            }

            var options = {
                quality: 75,
                targetWidth: 1000,
                targetHeight: 1000,
                saveToPhotoAlbum: false
            };
            Camera.getPicture(options).then(function(imageURI) {
                $scope.uploadimage(imageURI,'face');
            }, function(err) {
                alert("照相机：" + err);
            });
        };
        $scope.takePhone2 = function() {
            if (!navigator.camera) {
                alert('请在真机环境中使用拍照上传。')
                return;
            }

            var options = {
                quality: 75,
                targetWidth: 1000,
                targetHeight: 1000,
                saveToPhotoAlbum: false
            };
            Camera.getPicture(options).then(function(imageURI) {
                $scope.uploadimage(imageURI,'back');
            }, function(err) {
                alert("照相机：" + err);
            });
        };
        $scope.readAlbum1 = function() {
            if (!window.imagePicker) {
                alert('目前您的环境不支持相册上传。');
                return;
            }

            var options = {
                maximumImagesCount: 1,
                width: 1000,
                height: 1000,
                quality: 80
            };

            $cordovaImagePicker.getPictures(options).then(function(results) {
                var uri = results[0];

                $scope.uploadimage(uri, 'face');
            }, function(error) {
                alert(error);
            });
        };
        $scope.readAlbum2 = function() {
            if (!window.imagePicker) {
                alert('目前您的环境不支持相册上传。');
                return;
            }

            var options = {
                maximumImagesCount: 1,
                width: 1000,
                height: 1000,
                quality: 80
            };

            $cordovaImagePicker.getPictures(options).then(function(results) {
                var uri = results[0];

                $scope.uploadimage(uri, 'back');
            }, function(error) {
                alert(error);
            });
        };
        //保存身份证信息
        $scope.saveID = function() {
            var cardInfo = $scope.cardInfo;
            if(cardInfo.cardnumber == '') {
                $ionicPopup.alert({
                    title: '错误提示',
                    template: '请输入身份证号码!'
                });
                return;
            }
            if(cardInfo.address == '') {
                $ionicPopup.alert({
                    title: '错误提示',
                    template: '请输入身份证地址!'
                });
                return;
            }
            if(cardInfo.name == '') {
                $ionicPopup.alert({
                    title: '错误提示',
                    template: '请输入姓名!'
                });
                return;
            }
            if(cardInfo.nation == '') {
                $ionicPopup.alert({
                    title: '错误提示',
                    template: '请输入民族!'
                });
                return;
            }
            if(cardInfo.issuingauthority == '') {
                $ionicPopup.alert({
                    title: '错误提示',
                    template: '请输入签发机构!'
                });
                return;
            }
            cardInfo.validstartdate = $filter('date')(cardInfo.obj_validstartdate, "yyyy-MM-dd");
            if(cardInfo.validstartdate == '') {
                $ionicPopup.alert({
                    title: '错误提示',
                    template: '请输入有效开始时间!'
                });
                return;
            }
            cardInfo.validenddate = $filter('date')(cardInfo.obj_validenddate, "yyyy-MM-dd");
            if(cardInfo.validenddate == '') {
                $ionicPopup.alert({
                    title: '错误提示',
                    template: '请输入有效结束时间,长期为9999-12-31!'
                });
                return;
            }
            $ionicLoading.show();
            $http.get(RemoteUrl.save_cardinfo_url, {
                params: cardInfo
            })
                .success(function (res) {
                    $ionicLoading.hide();
                    if(res.success) {
                        $ionicPopup.alert({
                            title: '提示',
                            template: res.msg
                        });
                        $state.go('home.my_info',{assign_id:$stateParams.assign_id});
                    } else {
                        $ionicPopup.alert({
                            title: '错误提示',
                            template: res.msg
                        });
                    }
                }).error(function (err, status) {
                $ionicLoading.show({
                    noBackdrop: true,
                    template: err,
                    duration: 1500
                });
            });
        };
    });